/**
 * 将模板html内容拷贝到最终结果
 * @param { string } template_url html url
 * @returns Plugin
 */
declare function vitePluginCopyHtml(template_url: string): Promise<{
    name: string;
    writeBundle(options: any, data: any): void;
}>;

/**
 * 将一些vite不能处理的文件导出
 * @param { string } config 后缀文件
 * @returns vitePlugin
 */
declare function vitePluginExport(config: string): {
    name: string;
    transform(src: any, id: string): {
        code: string;
        map: null;
    } | undefined;
};

export { vitePluginCopyHtml, vitePluginExport };
